SystemOrganization addCategory: #ConfigurationOfOmniBrowserLukas!

Object subclass: #ConfigurationOfOmniBrowserLukas
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOmniBrowserLukas'!

!ConfigurationOfOmniBrowserLukas class methodsFor: 'private' stamp: 'pmm 8/30/2012 17:54'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfOmniBrowserLukas class methodsFor: 'private' stamp: 'pmm 8/30/2012 17:54'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfOmniBrowserLukas class methodsFor: 'metacello tool support' stamp: 'pmm 8/30/2012 17:54'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOmniBrowserLukas class methodsFor: 'metacello tool support' stamp: 'pmm 8/30/2012 17:54'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfOmniBrowserLukas class methodsFor: 'metacello tool support' stamp: 'pmm 8/30/2012 17:54'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfOmniBrowserLukas class methodsFor: 'accessing' stamp: 'pmm 8/30/2012 17:54'!
project

	^self new project! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'baselines' stamp: 'pmm 8/31/2012 16:48'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	"Refactoring"
	spec for: #'pharo1.3.x' do: [
		spec
			blessing: #baseline;
			repository: 'http://www.squeaksource.com/rb';
			package: 'AST-Core';
			package: 'AST-Semantic' with: [
				spec requires: 'AST-Core' ];
			package: 'Refactoring-Core' with: [
				spec requires: 'AST-Core' ];
			package: 'Refactoring-Changes' with: [
				spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Critics' with: [
				spec requires: #('Refactoring-Core' 'Refactoring-Environment') ];
			package: 'Refactoring-Environment' with: [
				spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Spelling' with: [
				spec requires: 'Refactoring-Core' ];
			package: 'Refactoring-Pharo-Platform' with: [
				spec requires: 'Refactoring-Core' ].
				
			spec group: 'Refactoring Engine' with: #('AST-Core' 'AST-Semantic' 'Refactoring-Core' 'Refactoring-Changes' 'Refactoring-Critics' 'Refactoring-Environment' 'Refactoring-Spelling' 'Refactoring-Pharo-Platform') ].
		
	"OmniBrowser"
	spec for: #'pharo1.3.x' do: [
		spec
			blessing: #baseline;
			repository: 'http://source.lukas-renggli.ch/omnibrowser';
			package: 'OmniBrowser';
			package: 'OB-Pharo-Platform' with: [
				spec requires: 'OmniBrowser' ];
			package: 'OB-Polymorph' with: [
				spec requires: 'OB-Pharo-Platform' ];
			package: 'OB-Standard' with: [
				spec
					requires: 'OmniBrowser';
					postLoadDoIt: #postLoadOBStandard ];
			package: 'OB-Shout' with: [
				spec requires: 'OB-Standard' ];
			package: 'OB-Refactory' with: [
				spec requires: #('OB-Standard' 'Refactoring-Core' 'Refactoring-Environment') ];
			package: 'OB-Regex' with: [
				spec requires: 'OB-Standard' ];
			package: 'OB-SUnitIntegration' with: [
				spec requires: 'OB-Standard' ].
			
			spec group: 'OB' with: #('OmniBrowser' 'OB-Pharo-Platform' 'OB-Polymorph' 'OB-Standard' 'OB-Shout' 'OB-Refactory' 'OB-Regex' 'OB-SUnitIntegration') ].
	
	"Tools"
	spec for: #'pharo1.3.x' do: [
		spec
			blessing: #baseline;
			repository: 'http://source.lukas-renggli.ch/unsorted';
			package: 'Shout';
			package: 'ECompletion';
			package: 'ECompletionOmniBrowser' with: [
				spec requires: #('OB-Standard' 'ECompletion') ].
			
			spec group: 'Tools' with: #('Shout' 'ECompletion' 'ECompletionOmniBrowser') ].
		
	spec for: #'pharo1.3.x' do: [
		spec group: 'default' with: #('Refactoring Engine' 'OB' 'Tools')]! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'symbolic versions' stamp: 'pmm 8/30/2012 18:06'!
bleedingEdge: spec
	<symbolicVersion: #'bleedingEdge'>

	spec for: #'pharo1.3' version: '1.0-baseline'
! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'symbolic versions' stamp: 'pmm 8/30/2012 18:06'!
development: spec
	<symbolicVersion: #'development'>
	
	spec for: #'pharo1.3' version: #'1.0-baseline'
! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'baselines' stamp: 'pmm 8/30/2012 17:58'!
postLoadOBStandard

	SystemBrowser default: (Smalltalk at: #OBSystemBrowserAdaptor).! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'accessing' stamp: 'pmm 8/30/2012 17:54'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'symbolic versions' stamp: 'pmm 8/31/2012 16:19'!
stable: spec
    <symbolicVersion: #'stable'>
    spec for: #'pharo1.3.x' version: '1.0'! !

!ConfigurationOfOmniBrowserLukas methodsFor: 'versions' stamp: 'pmm 8/31/2012 16:31'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	"Refactoring"
	spec for: #'pharo1.3.x' do: [
		
		spec
			package: 'AST-Core' with: 'AST-Core-lr.92';
			package: 'AST-Semantic' with: 'AST-Semantic-lr.15';
			package: 'Refactoring-Core' with: 'Refactoring-Core-lr.158';
			package: 'Refactoring-Changes' with: 'Refactoring-Changes-lr.21';
			package: 'Refactoring-Critics' with: 'Refactoring-Critics-lr.17';
			package: 'Refactoring-Environment' with: 'Refactoring-Environment-lr.9';
			package: 'Refactoring-Spelling' with: 'Refactoring-Spelling-lr.27';
			package: 'Refactoring-Pharo-Platform' with: 'Refactoring-Pharo-Platform-lr.1' ].
		
	"OmniBrowser"
	spec for: #'pharo1.3.x' do: [
		
		spec
			package: 'OmniBrowser' with: 'OmniBrowser-pmm.550';
			package: 'OB-Pharo-Platform' with: 'OB-Pharo-Platform-lr.8';
			package: 'OB-Polymorph' with: 'OB-Polymorph-lr.31';
			package: 'OB-Standard' with: 'OB-Standard-pmm.573';
			package: 'OB-Shout' with: 'OB-Shout-lr.16';
			package: 'OB-Refactory' with: 'OB-Refactory-lr.275';
			package: 'OB-Regex' with: 'OB-Regex-lr.30';
			package: 'OB-SUnitIntegration' with: 'OB-SUnitIntegration-lr.46' ].
		
	"Tools"
	spec for: #'pharo1.3.x' do: [
		
		spec
			package: 'Shout' with: 'Shout-lr.105';
			package: 'ECompletion' with: 'ECompletion-lr.146';
			package: 'ECompletionOmniBrowser' with: 'ECompletionOmniBrowser-lr.6' ].! !
